<?php
require_once("../../config/config_dir_raiz.php");
$config = new Config();
require_once($config->diretorio_raiz()."/src/controller/Funcoes_bd.php");
require_once($config->diretorio_raiz()."/src/model/Bi_tipo_dado.php");
class Bi_tipo_dadoDAO
{
	private $_funcoes_bd;
	private $_banco_atual;
	private $conexao;
	function __construct()
	{
		$this->conexao = Conexao::obterConexao();
		$this->_banco_atual = Conexao::getUtilizarBanco();
		$this->_funcoes_bd = new Funcoes_bd();
	}
	public function salvar($bi_tipo_dado)
	{
		$inputs = array();
		if($bi_tipo_dado->getCodigo() != "")
		{
			array_push($inputs, array('campo'=>':codigo', 'valor'=>$bi_tipo_dado->getCodigo()));
		}
		else
		{
			array_push($inputs, array('campo'=>':codigo', 'valor'=>null));
		}
		if($bi_tipo_dado->getTipo() != "")
		{
			array_push($inputs, array('campo'=>':tipo', 'valor'=>$bi_tipo_dado->getTipo()));
		}
		else
		{
			array_push($inputs, array('campo'=>':tipo', 'valor'=>null));
		}
		if($bi_tipo_dado->getTipo_bd() != "")
		{
			array_push($inputs, array('campo'=>':tipo_bd', 'valor'=>$bi_tipo_dado->getTipo_bd()));
		}
		else
		{
			array_push($inputs, array('campo'=>':tipo_bd', 'valor'=>null));
		}
		try
		{
			$sql = "INSERT INTO bi_tipo_dado (codigo, tipo, tipo_bd) VALUES (:codigo, :tipo, :tipo_bd)  ";
			return $this->_funcoes_bd->executarSql($sql,$inputs);
		}
		catch (Exception $e)
		{
			throw new Exception($e->getMessage());
		}
	}
	public function buscarBi_tipo_dado($codigo)
	{
		$inputs = array();
		array_push($inputs, array('campo'=>':codigo', 'valor'=>$codigo));
		$sql = "SELECT * FROM bi_tipo_dado where codigo = :codigo "; 
		$bi_tipo_dado = new Bi_tipo_dado();
		$rows_bi_tipo_dado = $this->_funcoes_bd->sqlArrayInputs($sql, $inputs);
		foreach ($rows_bi_tipo_dado as $row)
		{
			$bi_tipo_dado->setCodigo($row['codigo']);
			$bi_tipo_dado->setTipo($row['tipo']);
			$bi_tipo_dado->setTipo_bd($row['tipo_bd']);
		}
		return $bi_tipo_dado;
	}
	public function buscarFiltro($where)
	{
		$inputs = array();
		$sql = "SELECT * FROM bi_tipo_dado  ".$where;
		$lista_bi_tipo_dado = array();
		$rows_bi_tipo_dado = $this->_funcoes_bd->sql($sql);
		foreach ($rows_bi_tipo_dado as $row)
		{
			$bi_tipo_dado = new Bi_tipo_dado();
			$bi_tipo_dado->setCodigo($row['codigo']);
			$bi_tipo_dado->setTipo($row['tipo']);
			$bi_tipo_dado->setTipo_bd($row['tipo_bd']);
			array_push($lista_bi_tipo_dado, $bi_tipo_dado);
		}
		return $lista_bi_tipo_dado;
	}
	public function atualizar($bi_tipo_dado)
	{
		$inputs = array();
		if($bi_tipo_dado->getCodigo() != "")
		{
			array_push($inputs, array('campo'=>':codigo', 'valor'=>$bi_tipo_dado->getCodigo()));
		}
		else
		{
			array_push($inputs, array('campo'=>':codigo', 'valor'=>null));
		}
		if($bi_tipo_dado->getTipo() != "")
		{
			array_push($inputs, array('campo'=>':tipo', 'valor'=>$bi_tipo_dado->getTipo()));
		}
		else
		{
			array_push($inputs, array('campo'=>':tipo', 'valor'=>null));
		}
		if($bi_tipo_dado->getTipo_bd() != "")
		{
			array_push($inputs, array('campo'=>':tipo_bd', 'valor'=>$bi_tipo_dado->getTipo_bd()));
		}
		else
		{
			array_push($inputs, array('campo'=>':tipo_bd', 'valor'=>null));
		}
		try
		{
			$sql = "UPDATE  bi_tipo_dado  SET codigo = :codigo, tipo = :tipo, tipo_bd = :tipo_bd WHERE codigo = :codigo  ";
			return $this->_funcoes_bd->executarSql($sql,$inputs);
		}
		catch (Exception $e)
		{
			throw new Exception($e->getMessage());
		}
	}
	public function excluir($bi_tipo_dado)
	{
		try
		{
			$sql = "DELETE FROM bi_tipo_dado  WHERE codigo =  :codigo ";
			$inputs = array();
			array_push($inputs, array('campo'=>':codigo', 'valor'=>$bi_tipo_dado->getCodigo()));
			return $this->_funcoes_bd->executarSql($sql,$inputs);
		}
		catch (Exception $e)
		{
			throw new Exception($e->getMessage());
		}
	}
	public function listarTodosRegistros()
	{
		$inputs = array();
		$sql = "SELECT * FROM bi_tipo_dado";
		$listaBi_tipo_dado = array();
		$rows_bi_tipo_dado = $this->_funcoes_bd->sql($sql);
		foreach ($rows_bi_tipo_dado as $row)
		{
			$bi_tipo_dado = new Bi_tipo_dado();
			$bi_tipo_dado->setCodigo($row['codigo']);
			$bi_tipo_dado->setTipo($row['tipo']);
			$bi_tipo_dado->setTipo_bd($row['tipo_bd']);
			array_push($listaBi_tipo_dado,$bi_tipo_dado );
		}
		return $listaBi_tipo_dado;
	}
	public function buscarBi_tipo_dadoPorTipo($tipo)
	{
		$inputs = array();
		$sql = "SELECT * FROM bi_tipo_dado where tipo like '%".$tipo."%'";
		$lista_bi_tipo_dado = array();
		$rows_bi_tipo_dado = $this->_funcoes_bd->sql($sql);
		foreach ($rows_bi_tipo_dado as $row)
		{
			$bi_tipo_dado = new Bi_tipo_dado();
			$bi_tipo_dado->setCodigo($row['codigo']);
			$bi_tipo_dado->setTipo($row['tipo']);
			$bi_tipo_dado->setTipo_bd($row['tipo_bd']);
			array_push($lista_bi_tipo_dado, $bi_tipo_dado);
		}
		return $lista_bi_tipo_dado;
	}
	public function buscarBi_tipo_dadoPorTipo_bd($tipo_bd)
	{
		$inputs = array();
		$sql = "SELECT * FROM bi_tipo_dado where tipo_bd like '%".$tipo_bd."%'";
		$lista_bi_tipo_dado = array();
		$rows_bi_tipo_dado = $this->_funcoes_bd->sql($sql);
		foreach ($rows_bi_tipo_dado as $row)
		{
			$bi_tipo_dado = new Bi_tipo_dado();
			$bi_tipo_dado->setCodigo($row['codigo']);
			$bi_tipo_dado->setTipo($row['tipo']);
			$bi_tipo_dado->setTipo_bd($row['tipo_bd']);
			array_push($lista_bi_tipo_dado, $bi_tipo_dado);
		}
		return $lista_bi_tipo_dado;
	}
}